/* graphics.c generated by valac 0.56.2, the Vala compiler
 * generated from graphics.vala, do not modify */

/*
 * Copyright 2020 Andrey Kutejko <andy128k@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * For more details see the file COPYING.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

VALA_EXTERN void string_to_rgba (const gchar* color,
                     GdkRGBA* result);
VALA_EXTERN gchar* rgba_to_string (GdkRGBA* color);
VALA_EXTERN void calculate_light_color (GdkRGBA* color,
                            GdkRGBA* result);

void
string_to_rgba (const gchar* color,
                GdkRGBA* result)
{
	GdkRGBA rgba = {0};
	g_return_if_fail (color != NULL);
	memset (&rgba, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&rgba, color);
	*result = rgba;
	return;
}

gchar*
rgba_to_string (GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (color != NULL, NULL);
	_tmp0_ = *color;
	_tmp1_ = *color;
	_tmp2_ = *color;
	_tmp3_ = g_strdup_printf ("#%04x%04x%04x", (guint) ((gint) ((_tmp0_.red * 65535) + 0.5)), (guint) ((gint) ((_tmp1_.green * 65535) + 0.5)), (guint) ((gint) ((_tmp2_.blue * 65535) + 0.5)));
	result = _tmp3_;
	return result;
}

void
calculate_light_color (GdkRGBA* color,
                       GdkRGBA* result)
{
	GdkRGBA light = {0};
	gdouble brightness = 0.0;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	g_return_if_fail (color != NULL);
	memset (&light, 0, sizeof (GdkRGBA));
	_tmp0_ = *color;
	_tmp1_ = *color;
	_tmp2_ = *color;
	brightness = (_tmp0_.red + _tmp1_.green) + _tmp2_.blue;
	if (brightness > (1.0 / 1.1)) {
		GdkRGBA _tmp3_;
		GdkRGBA _tmp4_;
		GdkRGBA _tmp5_;
		_tmp3_ = *color;
		light.red = 0.9 * _tmp3_.red;
		_tmp4_ = *color;
		light.green = 0.9 * _tmp4_.green;
		_tmp5_ = *color;
		light.blue = 0.9 * _tmp5_.blue;
	} else {
		if (brightness > 0.04) {
			GdkRGBA _tmp6_;
			GdkRGBA _tmp7_;
			GdkRGBA _tmp8_;
			_tmp6_ = *color;
			light.red = 1.1 * _tmp6_.red;
			_tmp7_ = *color;
			light.green = 1.1 * _tmp7_.green;
			_tmp8_ = *color;
			light.blue = 1.1 * _tmp8_.blue;
		} else {
			GdkRGBA _tmp9_;
			GdkRGBA _tmp10_;
			GdkRGBA _tmp11_;
			_tmp9_ = *color;
			light.red = 0.04 + _tmp9_.red;
			_tmp10_ = *color;
			light.green = 0.04 + _tmp10_.green;
			_tmp11_ = *color;
			light.blue = 0.04 + _tmp11_.blue;
		}
	}
	light.alpha = 1.0;
	*result = light;
	return;
}

